# mypy-boto3-pinpoint-sms-voice

[![PyPI - mypy-boto3-pinpoint-sms-voice](https://img.shields.io/pypi/v/mypy-boto3-pinpoint-sms-voice.svg?color=blue)](https://pypi.org/project/mypy-boto3-pinpoint-sms-voice)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-pinpoint-sms-voice.svg?color=blue)](https://pypi.org/project/mypy-boto3-pinpoint-sms-voice)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-pinpoint-sms-voice?color=blue)](https://pypistats.org/packages/mypy-boto3-pinpoint-sms-voice)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.PinpointSMSVoice 1.17.63](https://boto3.amazonaws.com/v1/documentation/api/1.17.63/reference/services/pinpoint-sms-voice.html#PinpointSMSVoice)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.10.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-pinpoint-sms-voice docs](https://github.com/vemel/mypy_boto3_builder/service_docs/mypy_boto3_pinpoint_sms_voice/README.md)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-pinpoint-sms-voice](#mypy-boto3-pinpoint-sms-voice)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)

## How to install

Install `boto3-stubs` for `PinpointSMSVoice` service.

```bash
python -m pip install boto3-stubs[pinpoint-sms-voice]
```

## Usage

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[pinpoint-sms-voice]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint-sms-voice]'`

Both type checking and auto-complete should work for `PinpointSMSVoice`
service. No explicit type annotations required, write your `boto3` code as
usual.

### PyCharm

- Install `boto-stubs[pinpoint-sms-voice]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint-sms-voice]'`

Both type checking and auto-complete should work for `PinpointSMSVoice`
service. No explicit type annotations required, write your `boto3` code as
usual. Auto-complete can be slow on big projects or if you have a lot of
installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[pinpoint-sms-voice]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint-sms-voice]'`
- Run `mypy` as usual

Type checking should work for `PinpointSMSVoice` service. No explicit type
annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[pinpoint-sms-voice]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint-sms-voice]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `PinpointSMSVoice` service. No explicit type
annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`PinpointSMSVoiceClient` provides annotations for
`boto3.client("pinpoint-sms-voice")`.

```python
import boto3

from mypy_boto3_pinpoint_sms_voice import PinpointSMSVoiceClient

client: PinpointSMSVoiceClient = boto3.client("pinpoint-sms-voice")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: PinpointSMSVoiceClient = session.client("pinpoint-sms-voice")
```

### Literals

`mypy_boto3_pinpoint_sms_voice.literals` module contains literals extracted
from shapes that can be used in user code for type checking.

```python
from mypy_boto3_pinpoint_sms_voice.literals import (
    EventType,
)

def check_value(value: EventType) -> bool:
    ...
```

### Typed dictionaries

`mypy_boto3_pinpoint_sms_voice.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_pinpoint_sms_voice.type_defs import (
    CallInstructionsMessageTypeTypeDef,
    CloudWatchLogsDestinationTypeDef,
    EventDestinationDefinitionTypeDef,
    EventDestinationTypeDef,
    GetConfigurationSetEventDestinationsResponseTypeDef,
    KinesisFirehoseDestinationTypeDef,
    PlainTextMessageTypeTypeDef,
    SSMLMessageTypeTypeDef,
    SendVoiceMessageResponseTypeDef,
    SnsDestinationTypeDef,
    VoiceMessageContentTypeDef,
)

def get_structure() -> CallInstructionsMessageTypeTypeDef:
    return {
      ...
    }
```
